searchNodes=[{"doc":"","ref":"Spike.Surface.html","title":"Spike.Surface","type":"module"},{"doc":"Properties form :struct, required: true field :atom, required: true errors :map, required: true dirty_fields :map, required: false, default: nil Slots default, args: [:field_errors]","ref":"Spike.Surface.Errors.html","title":"Spike.Surface.Errors","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Spike.Surface.Errors.html#render/1","title":"Spike.Surface.Errors.render/1","type":"function"},{"doc":"Properties form :struct, required: true field :atom, required: true target :any, required: false, default: nil submit_event :string, required: false, default: &quot;submit&quot; Slots default","ref":"Spike.Surface.FormField.html","title":"Spike.Surface.FormField","type":"module"},{"doc":"Spike.Surface provides a wrapper around Surface.LiveView and Surface.LiveComponent , which simplifies working with memory-backed forms, including nested forms that require contextual validation.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding spike_surface to your list of dependencies in mix.exs : def deps do [ { :spike_surface , &quot;~&gt; 0.2&quot; } ] end Documentation can be found at https://hexdocs.pm/spike_surface .","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"Once installed in a Phoenix project, open up your *_web.ex file and add the following functions: def form_surface_live_view do quote do use Surface.LiveView , layout : { MyAppWeb.LayoutView , &quot;live.html&quot; } unquote ( view_helpers ( ) ) use Spike.Surface end end def form_surface_live_component do quote do use Surface.LiveComponent unquote ( view_helpers ( ) ) use Spike.Surface end end See Spike.LiveView for walkthrough, which is applicable here, and also see Spike Example app for Spike + Surface UI examples. For starting point to build your own form components, see our Components Library .","ref":"readme.html#quick-start","title":"Readme - Quick start","type":"extras"},{"doc":"This library only comes with building blocks for your components, and you should built your own form components - or use the provided building blocks directly. Feel free to grab and customize these components to your needs, and treat them as a starting point when building your form builder. The code below is released under public domain: defmodule MyAppWeb.Surface.FormComponents do defmodule Label do use Surface.Component prop ( form , :struct , required : true ) prop ( field , :atom , required : true ) prop ( text , :string , required : true ) prop ( required , :boolean , required : false , default : false ) def render ( assigns ) do ~F&quot;&quot;&quot; {#if @required} &lt;label for={&quot;\#{@form.ref}_\#{@field}&quot;}&gt;* {@text}&lt;/label&gt; {#else} &lt;label for={&quot;\#{@form.ref}_\#{@field}&quot;}&gt;{@text}&lt;/label&gt; {/if} &quot;&quot;&quot; end end defmodule Errors do use Surface.Component prop ( form , :struct , required : true ) prop ( errors , :map , required : true ) prop ( field , :atom , required : true ) def render ( assigns ) do ~F&quot;&quot;&quot; &lt;Spike.Surface.Errors form={@form} errors={@errors} field={@field} :let={field_errors: field_errors}&gt; &lt;span class=&quot;error&quot;&gt; {#for {_key, message} &lt;- field_errors} {message}&lt;br/&gt; {/for} &lt;/span&gt; &lt;/Spike.Surface.Errors&gt; &quot;&quot;&quot; end end defmodule Input do use Surface.Component alias MyAppWeb.Surface.FormComponents . { Errors , Label } prop ( form , :struct , required : true ) prop ( type , :string , required : true ) prop ( errors , :map , required : true ) prop ( field , :atom , required : true ) prop ( label , :string , required : false ) prop ( target , :any , required : false , default : nil ) prop ( options , :list , required : false , default : [ ] ) prop ( checked_value , :string , required : false , default : &quot;1&quot; ) prop ( unchecked_value , :string , required : false , default : &quot;0&quot; ) def render ( %{ type : type } = assigns ) when type in [ &quot;text&quot; , &quot;password&quot; , &quot;email&quot; , &quot;textarea&quot; ] do ~F&quot;&quot;&quot; &lt;div&gt; {#if @label} &lt;Label form={@form} field={@field} text={@label} required={is_required?(@form, @field)} /&gt; {/if} &lt;Spike.Surface.FormField form={@form} field={@field} target={@target}&gt; {#if @type == &quot;textarea&quot;} &lt;textarea id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot;&gt;{ @form |&gt; Map.get(@field) }&lt;/textarea&gt; {#else} &lt;input id={&quot;\#{@form.ref}_\#{@field}&quot;} type={@type} name=&quot;value&quot; value={@form |&gt; Map.get(@field)} /&gt; {/if} &lt;/Spike.Surface.FormField&gt; &lt;Errors form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end def render ( %{ type : &quot;select&quot; , options : _ } = assigns ) do ~F&quot;&quot;&quot; &lt;div&gt; {#if @label} &lt;Label form={@form} field={@field} text={@label} required={is_required?(@form, @field)} /&gt; {/if} &lt;Spike.Surface.FormField form={@form} field={@field} target={@target}&gt; &lt;select id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot;&gt; {#for {value, text} &lt;- @options} &lt;option value={value || &quot;&quot;} selected={@form |&gt; Map.get(@field) == value}&gt;{ text }&lt;/option&gt; {/for} &lt;/select&gt; &lt;/Spike.Surface.FormField&gt; &lt;Errors form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end def render ( %{ type : &quot;checkbox&quot; , options : _ } = assigns ) do ~F&quot;&quot;&quot; &lt;div&gt; &lt;Spike.Surface.FormField form={@form} field={@field} target={@target}&gt; &lt;span class=&quot;float-left&quot;&gt; &lt;input id={&quot;\#{@form.ref}_\#{@field}_unchecked&quot;} name=&quot;value&quot; type=&quot;hidden&quot; value={@unchecked_value} /&gt; &lt;input id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot; type=&quot;checkbox&quot; value={@checked_value} checked={is_checked?(@form, @field, @checked_value)} /&gt; &lt;/span&gt; &lt;span&gt; {#if @label} &lt;Label form={@form} field={@field} text={@label} required={is_required?(@form, @field)} /&gt; {/if} &lt;/span&gt; &lt;/Spike.Surface.FormField&gt; &lt;Errors form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end defp is_checked? ( form , field , checked_value ) do Map . get ( form , field ) == checked_value || Map . get ( form , field ) == true end defp is_required? ( form , field ) do validations = Vex.Extract . settings ( form ) |&gt; Map . get ( field , [ ] ) { :presence , true } in validations end end end Also see Spike Example app for more examples.","ref":"components_library.html","title":"Components Library","type":"extras"}]